// gbahearts.c AGBmain Entry point is contained here (main program loop)

const int __gba_multiboot;

#include <gba.h>
#include "stdlib.h"
#include "gbahearts.h"

const u16 ZoomSin[] = {
	256 , 258 , 265 , 277 , 293 , 312 , 335 , 359 , 384 , 408 , 432 , 455 , 474 ,
	490 , 502 , 509 , 511 , 509 , 502 , 490 , 474 , 455 , 432 , 408 , 383 , 359 ,
	335 , 312 , 293 , 277 , 265 , 258 
};

char myname[32];

void IntrHandlr(void) {
	Random();
	IF=IF;
}

void intrort();
void creditsrt();
void startrt();
void nextsfxrt();
void prevsfxrt();
void playsfxrt();

// routines: 0:intro, 1:credits, 2:start, 3:nextsfx, 4:prevsfx, 5:playsfx	
const u32 funclist[]= {
	(u32)&intrort,(u32)&creditsrt,(u32)&startrt,(u32)&nextsfxrt,(u32)&prevsfxrt,(u32)&playsfxrt	
};




// menu data
char SfxTstDisp[5];
u8 SfxTstNum;

const struct MenuItm IntroItm={20,70,10,12,1,2,"Introduction",{0,0,1,1,0,0,5,1,0,5},{0,0,1,3,0,0,0,1,0,0}};
const struct MenuItm StartItm={30,90,10,10,1,2,"Start Game",{0,0,1,1,0,0,5,1,0,5},{0,0,2,0,0,0,2,2,0,2}};
const struct MenuItm OptionsItm={20,110,10,12,1,2,"Game Options",{0,0,1,1,0,0,2,1,0,2},{0,0,3,1,0,0,1,3,0,1}};
const struct MenuItm CreditsItm={45,130,10,7,1,2,"Credits",{0,0,1,1,0,0,5,1,0,5},{0,0,0,2,0,0,1,0,0,1}};
// routines: 0:intro, 1:credits, 2:start, 3:nextsfx, 4:prevsfx, 5:playsfx
const struct MenuItm OptSfxTstNextItm={100,80,10,2,1,2,"->",{0,0,1,1,1,1,4,1,0,4},{0,0,2,4,1,1,3,2,0,3}};	
const struct MenuItm OptSfxTstPrevItm={40,80,10,2,1,2,"<-",{0,0,1,1,1,1,4,1,0,4},{0,0,2,4,0,0,4,0,0,4}};
const struct MenuItm OptSfxTstTestItm={60,100,10,4,1,2,"Play",{0,0,1,1,0,0,4,1,0,4},{0,0,4,1,0,0,5,3,0,5}};
const struct MenuItm OptSfxTstDispItm={70,80,10,2,1,2,SfxTstDisp,{0,0,0,0,0,0,0,0,0,0},{0,0,0,2,0,0,1,0,0,1}};
const struct MenuItm OptReturnItm={50,120,10,6,1,2,"Return",{0,0,1,1,0,0,2,1,0,2},{0,0,1,2,0,0,0,1,0,0}};

const struct MenuScrn IntroMenu={4,0,1,2,{0,0,0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0,0,0},{(struct MenuItm *)&IntroItm,(struct MenuItm *)&StartItm,(struct MenuItm *)&OptionsItm,(struct MenuItm *)&CreditsItm}};
const struct MenuScrn OptionsMenu={5,1,1,3,{0,0,0,0,0,0,0,0,2,0},{0,0,0,0,0,0,0,0,0,0},{(struct MenuItm *)&OptSfxTstNextItm,(struct MenuItm *)&OptSfxTstPrevItm,(struct MenuItm *)&OptSfxTstTestItm,(struct MenuItm *)&OptSfxTstDispItm,(struct MenuItm *)&OptReturnItm}};

const struct MenuData MainMenu={2,0,funclist,{(struct MeunScrn *)&IntroMenu,(struct MeunScrn *)&OptionsMenu}};


void SfxTstPrnt(void) {
	SfxTstDisp[0]=(SfxTstNum/10)%10+'0';
	SfxTstDisp[1]=(SfxTstNum%10)+'0';
}

// main routine
void AgbMain(void)
{
	// intro code
	DISPSTAT=0x0008;	// request vblank interrupt
	INTRHANDLADDR=(u32)&IntrHandlr;
	IE=1;
	IME=1;


	// initialize global variables
	int i;
	SfxTstNum=0;
	SfxTstPrnt();
	InitRandom(0x1337d00d);
	SetupGBCSound();

	// load gbadev logo into vram
	//for(i=0;i<160*240;i++) VRAM[i]=introscrn[i];
	RLE16decompress((u16 *)introscrn,VRAM,160*240);
	// fade from white to gbadev logo
	BLDMOD=0x0084;
	COLY=16;
	DISPCNT=0x0403;
	for(i=64;i>0;i--) {
		wait_vblank();
		COLY=i/4;
	}
	BLDMOD=0;
	UpdateKeys();UpdateKeys();

	// pause - 4 seconds
	for(i=0;i<60*4;i++) {
		wait_vblank();
		if(UpdateKeys()) break;
	}
	// fade from gbadev logo to black
	COLY=0;
	BLDMOD=0x00D4;
	for(i=0;i<=32;i++) {
		wait_vblank();
		COLY=i/2;
	}
	
	// main menu code
	// load bg + sprite GFX
	//for(i=0;i<160*240;i++) VRAM[i]=mnuscrn[i];
	RLE16decompress((u16 *)mnuscrn,VRAM,160*240);


	InitMenu((struct MenuData *)&MainMenu);	
	// that call kills oam, so let's enable sprites
	DISPCNT=0x1403;
	// while we're at it let's load the sprites in :)
	for(i=0;i<32*256;i++) VRAMSPR1[i]=fontdata[i*2]+(fontdata[i*2+1]<<8);

	UpdateKeys();
	UpdateKeys();	// stop previous key presses

	// if we multibooted, let's go directly to multiplayer mode :)


	UpdateMenu(); /// get sprites on screen before we fade in
	// fade in
	for(i=16;i>=0;i--) {
		wait_vblank();
		COLY=i;
	}

	// main loop
	do {
		wait_vblank();
		UpdateKeys();
	// call generic menu handler
		UpdateMenu();

	// loop back
	} while(1);


	// game play code



}

//end of entry point

void intrort() {
u8 i;
	killOam();
SpritePrint(0,8,70,8,"Please search the ",-1,0);
SpritePrint(20,8,80,8,"  web for hearts  ",-1,0);
SpritePrint(40,8,90,8,"   instructions.  ",-1,0);
SpritePrint(60,8,100,8,"(section not done)",-1,0);
SpritePrint(80,70,120,12,"Ok",0,0);
i=0;
do {
	wait_vblank();
	UpdateKeys();
	SetOamZoom(0,ZoomSin[(i++)%32]);
	if(KeyPressed(KEY_A)) {
		killOam();
		return;
	}
} while(1);

}


// Gradient made by GBA Color Gradient Designer
const u16 creditsGradient[24] = {
    0x3E0, 0x360, 0x2E0, 0x260, 0x1E0, 0x160, 0xE0, 0x60, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
    0x0, 0x60, 0xE0, 0x160, 0x1E0, 0x260, 0x2E0, 0x360
};
const u8 creditstext[][17] = {
//  "0123456789ABCDEF"
	"   GBA Hearts",
	"  ------------",
	"By Stephen Stair",
	"   (sgstair)",
	"",
	"Written for the",
	"GBADEV.org 2002",
	"  Hearts Compo",
	"",
	"Thanks to:",
	"Joat, Costis,",
	"Forgotten,",
	"deeno_, Boofly",
	"",
	"(see readme to)",
	"(   see why   )",
	"",
//  "0123456789ABCDEF"
	"Greets to:",
	"   OneManBand,",
	"   DuoDreamer,",
	"     Goury,",
	"   BigRedPimp,",
	"   meepmouse,",
//  "0123456789ABCDEF"
	"  frog_e_style,",
	"  all others on",
	"   #gbadev and",
	"#gameart on",
	"EFnet, and",
	"Others i've",
	"probably",
	"forgotten, too"
	"",
	"",
//  "0123456789ABCDEF"
	"________________",
	"For more of",
	"sgstair's",
	"GBA and PC",
	"programs, visit",
	"www.akkit.org/",
	"sgstair",
	"",
	"This game is",
	"still incomplete",
	"More features,",
	"such as",
	"animation and",
	"multiplayer",
	"will be added in",
	"the future!"
};
#define topscrollieline 60
#define leftscrollie 16


void creditsrt() {
u16 i,j,creditline,creditlines;
u16 topyline;

	killOam();
	SetWindowPos(0,0,240,topscrollieline+8,topscrollieline+64);
	ShowWindow(0);
	WININ=0xFFFF;
	WINOUT=0x000F;
creditlines=sizeof(creditstext)/17;
topyline=31; // allow for 1/2 steps
creditline=0;
for(i=0;i<8;i++)
	SPRPAL[i+1]=0;
do {
	wait_vblank();
	UpdateKeys();
	// update scrollie :)

	// draw scrollie:
	killOam();
	for(i=0;i<8;i++) {
		if((creditline+i)<8 || (creditline+i)>(creditlines+7)) { // not visible yet/ not visible anymore
		} else {
			SpritePrint(i*16,leftscrollie,topscrollieline+(topyline/4)+i*8,8,creditstext[creditline+i-8],-1,0);
		}
	}
	if(topyline==0) {
		topyline=32;
		creditline++;
	}
	topyline--;
	if(creditline>(creditlines+10)) creditline=0;

	if(KeyPressed(KEY_A)) {
		killOam();
		return;
	}
} while(1);


}
void startrt() {
	u32 a,b,i;
	EnterPlayerName();
	killOam();
	for(i=0;i<16;i++) SPRPAL[i]=0;
		SPRPAL[0]=0x7fff;

	SetOamZoom(0,0);
	SetOamZoom(1,0);
	a=SpritePrint(0,10,80,10,"Single Player",0,0);
	a=SpritePrint(a,20,110,10,"MultiPlayer",1,0);
	for(i=0;i<17;i++) {
		wait_vblank();
		SetOamZoom(0,ZoomSin[i]-255);
		SetOamZoom(1,ZoomSin[i]-255);
	}
	b=0;
	i=0;
	do {
		wait_vblank();
		UpdateKeys();
		if(b==0) {
			SetOamZoom(1,256);
			SetOamZoom(0,ZoomSin[(i++)%32]);
		} else {
			SetOamZoom(0,256);
			SetOamZoom(1,ZoomSin[(i++)%32]);
		}
		if(KeyPressed(KEY_UP) || KeyPressed(KEY_DN) || KeyPressed(KEY_SEL)) {
			PlayGBCSound(1);
			b=(b+1)%2;
		}
		if(KeyPressed(KEY_A) || KeyPressed(KEY_STR)) {
			PlayGBCSound(2);
			if(b==0) {
				SetupSinglePlay();
				if(AISelectScreen()) break;
					RLE16decompress((u16 *)mnuscrn,VRAM,160*240);
					DISPCNT=0x1403;
				return;
			} else {
				if(MultiPlayScreen()) break;
					RLE16decompress((u16 *)mnuscrn,VRAM,160*240);
					DISPCNT=0x1403;
				return;
			}
		}
		if(KeyPressed(KEY_B)) {
			PlayGBCSound(3);
			break;
		}

	}while(1);
	do {
		wait_vblank();
		if(b==0) {
			SetOamZoom(1,256);
			SetOamZoom(0,ZoomSin[(i++)%32]);
		} else {
			SetOamZoom(0,256);
			SetOamZoom(1,ZoomSin[(i++)%32]);
		}
	} while((i%32));
	for(i=17;i>0;i--) {
		wait_vblank();
		SetOamZoom(0,ZoomSin[i]-255);
		SetOamZoom(1,ZoomSin[i]-255);
	}
}

void nextsfxrt() {
	if(SfxTstNum<99)SfxTstNum++;
	SfxTstPrnt();
}
void prevsfxrt() {
	if(SfxTstNum>0)SfxTstNum--;
	SfxTstPrnt();
}
void playsfxrt() {
	PlayGBCSound(SfxTstNum+1);
}

